﻿

var ID_COLUMN = 0;
var DESCRIPTION_COLUMN = 1;
var CONVERTED_COLUMN = 2;
var VOLTS_COLUMN = 4;
var OFFSET_COLUMN = 6;
var UNITS_COLUMN = 7;

//Include misc functions
document.write("<script src='/user/misc.js' type='text/javascript'></script>");
document.write("<script src='/admin/settings.js' type='text/javascript'></script>");
document.write("<script src='/user/splash.js' type='text/javascript'></script>");

//global variables
var auxSettings;
var auxTable;
var timeout;
var splashDiv;







// Start by requesting the channel settings so we know which curves to ask for.
window.onload = initialize;


//////////////////////////////////////////////////////////////////////////////
function initialize()
{
	auxSettings = new auxInputSettings();
	
	timeout = setTimeout(xmlTimeout, 2000);			
	auxSettings.getSettings();	//this call blocks	
	clearXmlTimeout();
	
	
	//create new table
	auxTable = document.createElement("table");
	document.getElementById('auxTableLayer').appendChild(auxTable);	
	auxTable.className = "data_table";
	auxTable.id = "aux_input_table";
		
	var caption = auxTable.createCaption();
	caption.innerHTML="Aux Input Scales";

	//Created header row	
	auxTable.createTHead();
	
	var headerRow = auxTable.tHead.insertRow(-1);
	headerRow.className = "data_table_header";
	
	var newCell = headerRow.insertCell(ID_COLUMN);
	newCell.innerHTML =  "ID";
	newCell.className = "data_table_header_cell";
			
	newCell = headerRow.insertCell(DESCRIPTION_COLUMN);
	newCell.innerHTML =  "Description";
	newCell.className = "data_table_header_cell";

	newCell = headerRow.insertCell(CONVERTED_COLUMN);
	newCell.innerHTML =  "Converted";
	newCell.className = "data_table_header_cell";
	
	newCell = headerRow.insertCell(-1);
	newCell.innerHTML =  "";
	newCell.className = "data_table_header_cell";
	

	newCell = headerRow.insertCell(VOLTS_COLUMN);
	newCell.innerHTML =  "Volts";
	newCell.className = "data_table_header_cell";
	

	newCell = headerRow.insertCell(-1);
	newCell.innerHTML =  "";
	newCell.className = "data_table_header_cell";

	newCell = headerRow.insertCell(OFFSET_COLUMN);
	newCell.innerHTML =  "Offset";
	newCell.className = "data_table_header_cell";
	
	newCell = headerRow.insertCell(-1);
	newCell.innerHTML =  "Units";
	newCell.className = "data_table_header_cell";

  	var tableBody = document.createElement("TBODY");
  	auxTable.appendChild(tableBody);

	updateTable();


}// initialize


//////////////////////////////////////////////////////////////////////////////
//update settings table with current settings
function updateTable()
{
  	var tableBody = auxTable.tBodies[0];

	for ( var i=0; i < auxSettings.channels.length; i++){
		var id;
		var channel = 	auxSettings.channels[i]; //for convenience
		var row = tableBody.rows[i];
		if( row == null ) {
			row = tableBody.insertRow(-1);
			
			//add cell for channel id
			var newCell = row.insertCell(ID_COLUMN);
			newCell.className = "data_table_cell";
			
			//add cell for channel description
			newCell = row.insertCell(DESCRIPTION_COLUMN);
			newCell.className = "data_table_cell";
			var newInput = document.createElement("input");
			newInput.setAttribute("name","description");
			newInput.setAttribute("type","text");
			newInput.setAttribute("onChange","inputChanged(this)");
			newCell.appendChild(newInput);
			
			//add cell for channel converted reference
			newCell = row.insertCell(CONVERTED_COLUMN);
			newCell.className = "data_table_cell";
			newInput = document.createElement("input");
			newInput.className = "aux_numeric_input";
			newInput.setAttribute("name","converted_ref");
			newInput.setAttribute("type","text");
			newInput.setAttribute("onChange","inputChanged(this)");
			newCell.appendChild(newInput);
		
			
			newCell = row .insertCell(-1);
			newCell.innerHTML = "Units Per" ;
			newCell.className = "data_table_cell"
		
			newCell = row.insertCell(VOLTS_COLUMN);
			newCell.className = "data_table_cell";
			newInput = document.createElement("input");
			newInput.className = "aux_numeric_input";
			newInput.setAttribute("name","voltage_ref");
			newInput.setAttribute("type","text");
			newInput.setAttribute("onChange","inputChanged(this)");
			newCell.appendChild(newInput);
		
			newCell = row.insertCell(-1);
			newCell.innerHTML = "Volts" ;
			newCell.className = "data_table_cell";
			newCell.setAttribute("width","50px");
			newCell.setAttribute("style", "text-align:left");
			
			newCell = row.insertCell(OFFSET_COLUMN);
			newCell.className = "data_table_cell";
			newInput = document.createElement("input");
			newInput.className = "aux_numeric_input";
			newInput.setAttribute("name","converted_offset");
			newInput.setAttribute("type","text");
			newInput.setAttribute("onChange","inputChanged(this)");
			newCell.appendChild(newInput);


			newCell = row.insertCell(UNITS_COLUMN);
			newCell.className = "data_table_cell";
			newInput = document.createElement("input");
			newInput.className = "aux_units_input";
			newInput.setAttribute("name","units");
			newInput.setAttribute("type","text");
			newInput.setAttribute("onChange","inputChanged(this)");
			newCell.appendChild(newInput);



//			newCell = row.insertCell(-1);
//			newCell.innerHTML = "Units" ;
//			newCell.className = "data_table_cell";

		}
		
		row.cells[ID_COLUMN].innerHTML = channel.id ;		
		row.cells[DESCRIPTION_COLUMN].getElementsByTagName('input')[0].value = channel.description;
		row.cells[CONVERTED_COLUMN].getElementsByTagName('input')[0].value = parseFloat(channel.convertedReference).toPrecision(6);
		row.cells[VOLTS_COLUMN].getElementsByTagName('input')[0].value = parseFloat(channel.voltageReference).toPrecision(6);		
		row.cells[OFFSET_COLUMN].getElementsByTagName('input')[0].value = parseFloat(channel.convertedOffset).toPrecision(6);	
		row.cells[UNITS_COLUMN].getElementsByTagName('input')[0].value = channel.convertedUnits;
	}//end for i = 
}



//////////////////////////////////////////////////////////////////////////////
function inputChanged( inputBox )
{
	//get the table row that this input belongs too
	var row = null;
	var cell = inputBox.parentNode;
	if( cell != null ) {
		row = cell.parentNode;
	}
	
	//if we don't have a row, we don't know what is going on.
	if( row == null ) {
		return;
	}
	
	var idCell = row.cells[ID_COLUMN];
	if( idCell == null ) {
		return; //can't work without id cell;
	}
	
	//finally get id
	var id = idCell.innerHTML;

	//find settigns entry with this id value (could have used row index, but ID is what realy matters)
	for ( var i=0; i < auxSettings.channels.length; i++){
		var channel = 	auxSettings.channels[i]; //for convenience
		
		//only update channel settings if a matching ID was found
		if( channel.id == id ) {			
			//figure which field was change
			if( inputBox.name == "description" ) {
				channel.description = row.cells[DESCRIPTION_COLUMN].getElementsByTagName('input')[0].value;	
				
			}else if( inputBox.name == "converted_ref" ) {
				channel.convertedReference = row.cells[CONVERTED_COLUMN].getElementsByTagName('input')[0].value;				

			}else if( inputBox.name == "converted_offset" ) {
				channel.convertedOffset = row.cells[OFFSET_COLUMN].getElementsByTagName('input')[0].value;	


			}else if( inputBox.name == "units" ) {
				channel.convertedUnits = row.cells[UNITS_COLUMN].getElementsByTagName('input')[0].value;	

						
			}else if( inputBox.name == "voltage_ref" ) {
				channel.voltageReference =  parseFloat(row.cells[VOLTS_COLUMN].getElementsByTagName('input')[0].value).toExponential(8);
			}
		
			channel.dirty = true;
		}
	}//end for i = 

}// input changed



//////////////////////////////////////////////////////////////////////////////
// Asynchronously set global settings
function setAuxInputSettings()
{	
	//channel data was kept up-to-date when changes were made, so we don't need to do anyting here for that.
	// So simply "set" the settings
	timeout = setTimeout(xmlTimeout, 1000);			
	auxSettings.setSettings();	//this call blocks	
	clearXmlTimeout();
}//set aux settings


////////////////////////////////////////////////////////////////////////////////////////////
function xmlTimeout()
{
	splashDiv = getSplash("Mutli-Tracer Busy", "Please wait", document.getElementById('content_holder') );
	splashDiv.id = "splash";
}

////////////////////////////////////////////////////////////////////////////////////////////
function clearXmlTimeout()
{
	clearTimeout(timeout);
	var splash = document.getElementById('splash') ;	
	if( splash != null ){
		document.getElementById('content_holder').removeChild(splash);
	}
}




