﻿
var GPM_ALL_OFF = 0;
var GPM_ALL_PEAK_TRACK = 1;
var GPM_ALL_VOLTAGE_TRACK = 2;
var GPM_ALL_PROFILE = 3;
var GPM_CHANNEL_DEFINED = 4;

var GCM_NO_CURVES = 0;
var GCM_ALL_CURVES = 1;
var GCM_CHANNEL_DEFINED = 2;


//Include misc functions
document.write("<script src='/user/misc.js' type='text/javascript'></script>");
document.write("<script src='/user/splash.js' type='text/javascript'></script>");


//global variables
var xmlhttp;
var xmlSettingsDoc= null;
var timeout;
var splashDiv;


// Start by requesting the channel settings so we know which curves to ask for.
window.onload = initialize;

//////////////////////////////////////////////////////////////////////////////
// Asynchronously request settings
function initialize()
{
//		alert("Start global setting script");
	xmlhttp = misc_getXmlRequestObject();
//		alert("Start global setting script 2");
	getGlobalSettings();
}

//////////////////////////////////////////////////////////////////////////////
// Asynchronously request settings
function getGlobalSettings()
{	
//		alert("get Globasl Settings");

	if (xmlhttp!=null){
		xmlhttp.open("GET","/admin/global_settings.xml",true);
		xmlhttp.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
		xmlhttp.onreadystatechange = onGlobalSettingsResponse;  
		xmlhttp.send(null);
		timeout = setTimeout(xmlTimeout, 2000);
	}else{
		alert("Your browser does not support XMLHTTP.");
	}
}//get Settings

//////////////////////////////////////////////////////////////////////////////
function onGlobalSettingsResponse()
{
	if(xmlhttp.readyState!=4){
		return;
	}

	if(xmlhttp.status == 0 ){
		//Ststus that seems to happen when we close a page with a pending request.
		return;
	}
	
	if(xmlhttp.status!=200){
		alert("Problem retrieving XML data");
		return;
	}

	clearXmlTimeout();
	
	var loadGlobals ;
	var curveGlobals ;
	var loadMode ;
	var curveMode ;
	
	//Get global element
	loadGlobals = xmlhttp.responseXML.documentElement.getElementsByTagName("Loads");
	curveGlobals = xmlhttp.responseXML.documentElement.getElementsByTagName("Curves");
	
	try{	
		loadMode = parseInt(loadGlobals[0].getAttribute("power_mode"));
	}catch (er){
		loadMode = 0;
	}		
	

	misc_setRadioValue(document.global_form.powerModeGroup, 0 ); //default to mode 0 
	misc_setRadioValue(document.global_form.powerModeGroup, loadMode );


	try{	
		curveMode = parseInt(curveGlobals[0].getAttribute("curve_mode"));
	}catch (er){
		curveMode = 0;
	}		

	misc_setRadioValue(document.global_form.curveModeGroup, 0 ); //default to mode 0 
	misc_setRadioValue(document.global_form.curveModeGroup, curveMode );


} // on Reponse serttings


//////////////////////////////////////////////////////////////////////////////
// Asynchronously set global settings
function setGlobalSettings()
{

	//create an XML document to send back settings
	xmlSettingsDoc= misc_createXmlDoc();
	
	var root = xmlSettingsDoc.createElement("Settings");
	xmlSettingsDoc.appendChild(root );
	
	
	var globalsElem = xmlSettingsDoc.createElement("Globals");
	root.appendChild(globalsElem );
	
	var loadsElem = xmlSettingsDoc.createElement("Loads");
	globalsElem .appendChild(loadsElem );
	loadsElem.setAttribute("power_mode",misc_getRadioValue(document.global_form.powerModeGroup) );
	
	var curvesElem = xmlSettingsDoc.createElement("Curves");
	globalsElem .appendChild(curvesElem );
	curvesElem.setAttribute("curve_mode",misc_getRadioValue(document.global_form.curveModeGroup) );

	xmlhttp = misc_getXmlRequestObject();
	
	if (xmlhttp!=null){
		xmlhttp.open("POST","/admin/set_global_settings",true);
		xmlhttp.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
		xmlhttp.onreadystatechange = onGlobalSettingsResponse;  //read back settings
		xmlhttp.send(xmlSettingsDoc);
		timeout = setTimeout(xmlTimeout, 2000);

	}else{
		alert("Your browser does not support XMLHTTP.");
	}
}//getSample



////////////////////////////////////////////////////////////////////////////////////////////
function xmlTimeout()
{
	splashDiv = getSplash("Mutli-Tracer Busy", "Please wait", document.getElementById('content_holder') );
	splashDiv.id = "splash";
}

////////////////////////////////////////////////////////////////////////////////////////////
function clearXmlTimeout()
{
	clearTimeout(timeout);
	var splash = document.getElementById('splash') ;	
	if( splash != null ){
		document.getElementById('content_holder').removeChild(splash);
	}
}


