﻿
//Include misc functions
//document.write("<script src='/user/misc.js' type='text/javascript'></script>");

//global variables
var xmlhttp;
var tempTable;
var auxTable;
var modTable;


var voltsDigits = 3;
var ampsDigits = 3;
var powerDigits = 2;
var tempDigits = 1;
var auxPrecision = 6;

var timeout;

//Function references
var initialize;
var getSample;
var onResponse;



// Gte a new sample as soon as we load the page
window.onload = initialize;

//////////////////////////////////////////////////////////////////////////////
function initialize()
{
	//create a single instance once for each of the teo xml http request objects we need
	xmlhttp = misc_getXmlRequestObject();
	
	getSample();
}


//////////////////////////////////////////////////////////////////////////////
// Asynchronously request a sample
function getSample()
{
	if (xmlhttp!= null){
		xmlhttp.open("GET","/user/sample.xml",true);
		xmlhttp.setRequestHeader("If-Modified-Since", "Fri, 31 Dec 1999 23:59:59 GMT"); //forces new data
		xmlhttp.onreadystatechange=onResponse;  
		xmlhttp.send(null);
		timeout = setTimeout(xmlTimeout, 2000);
	}else{
		alert("Your browser does not support XMLHTTP.");
	}
}//getSample


//////////////////////////////////////////////////////////////////////////////
function onResponse()
{
	var temperatures;
	var newTable;
	var headerRow;
	var newCell, modules, modId;
	var caption, value, units;
	var i, descript;
	var newRow, tempId, auxId, aux_inputs;
	
	if(xmlhttp.readyState!=4){
		return;
	}
	
	if(xmlhttp.status == 0 ){
		//Ststus that seems to happen when we close a page with a pending request.
		return;
	}
	
	if(xmlhttp.status!=200){
		alert("Problem retrieving XML data");
		return;
	}
	
	clearTimeout(timeout);
	
	//build Temperature input table	
	temperatures = xmlhttp.responseXML.documentElement.getElementsByTagName("Temp");
	
	//create new table
	newTable = document.createElement("table");
	newTable.className = "data_table";
	newTable.id = "temperature_table";
		
	caption = newTable.createCaption()
	caption.innerHTML="Temperatures"

	//Created header row	
	newTable.createTHead();
	
	headerRow = newTable.tHead.insertRow(-1);
	headerRow .className = "data_table_header";
	
	newCell = headerRow.insertCell(0);
	newCell.innerHTML =  "ID";
	newCell.className = "data_table_header_cell";
			
	newCell = headerRow.insertCell(1);
	newCell.innerHTML =  "Description";
	newCell.className = "data_table_header_cell";

	newCell = headerRow.insertCell(2);
	newCell.innerHTML =  "Value (C)";
	newCell.className = "data_table_header_cell";

//	newCell = headerRow.insertCell(3);
//	newCell.innerHTML =  " ";
//	newCell.className = "data_table_header_cell";

			 		 		 			
	for (i=0; i < temperatures.length; i++){	
		newRow = newTable.insertRow(-1);
		
		try{	
			tempId=temperatures[i].getAttribute("id");
		}catch(er){
			tempId = "unknown";
		}
		newCell = newRow .insertCell(0);
		newCell.innerHTML = tempId;
		newCell.className = "data_table_cell";
		
		try{	
			descript = temperatures[i].getAttribute("description");
		}catch(er){
			descript = "unknown";
		}
		newCell = newRow .insertCell(1);
		newCell.innerHTML = descript ;
		newCell.className = "data_table_cell";
		
		try{	
			value = parseFloat(temperatures[i].getAttribute("value")).toFixed(tempDigits);
		}catch(er){
			value = "unknown";
		}
		newCell = newRow .insertCell(2);
		newCell.innerHTML = value ;
		newCell.className = "data_table_cell";
		
/*		
		try{	
			units = temperatures[i].getAttribute("units");
		}catch(er){
			units = "unknown";
		}
		newCell = newRow .insertCell(3);
		newCell.innerHTML = units ;
		newCell.className = "data_table_cell";
*/		

			
	}//end for i = 

	try {
		document.getElementById('temperatureTable').removeChild( tempTable  );//remove previous table
	}catch(er){
	}
	tempTable = newTable;
	document.getElementById('temperatureTable').appendChild(tempTable);
	


	//build Aux Input input table	
	aux_inputs = xmlhttp.responseXML.documentElement.getElementsByTagName("Aux");
	
	//create new table
	newTable = document.createElement("table");
	newTable.className = "data_table";
	newTable.id = "aux_input_table";
		
	caption = newTable.createCaption()
	caption.innerHTML="Aux Inputs"


	//Created header row
	newTable.createTHead();
	
	headerRow = newTable.tHead.insertRow(-1);
	headerRow .className = "data_table_header";
	
	newCell = headerRow.insertCell(0);
	newCell.innerHTML =  "ID";
	newCell.className = "data_table_header_cell";
			
	newCell = headerRow.insertCell(1);
	newCell.innerHTML =  "Description";
	newCell.className = "data_table_header_cell";

	newCell = headerRow.insertCell(2);
	newCell.innerHTML =  "Value";
	newCell.className = "data_table_header_cell";	
	
	newCell = headerRow.insertCell(3);
	newCell.innerHTML =  "Units";
	newCell.className = "data_table_header_cell";

			 		 		 			
	for (i=0; i < aux_inputs.length; i++){	
		newRow = newTable.insertRow(-1);
		
		try{	
			auxId = aux_inputs[i].getAttribute("id");
		}catch(er){
			auxId= "unknown";
		}
		newCell = newRow .insertCell(0);
		newCell.innerHTML = auxId ;
		newCell.className = "data_table_cell";
		
		try{	
			descript = aux_inputs[i].getAttribute("description");
		}catch(er){
			descript = "unknown";
		}
		newCell = newRow .insertCell(1);
		newCell.innerHTML = descript ;
		newCell.className = "data_table_cell";
		
		try{	
			value = parseFloat(aux_inputs[i].getAttribute("value")).toPrecision(auxPrecision);
		}catch(er){
			value = "unknown";
		}
		newCell = newRow .insertCell(2);
		newCell.innerHTML = value ;
		newCell.className = "data_table_cell";
		
		
		try{	
			units = aux_inputs[i].getAttribute("units");
		}catch(er){
			units = "";
		}
		newCell = newRow .insertCell(3);
		newCell.innerHTML = units ;
		newCell.className = "data_table_cell";

			
	}//end for i = 
	
	try {
		document.getElementById('auxTable').removeChild( auxTable );//remove previous table
	}catch(er){
	}
	auxTable = newTable;
	document.getElementById('auxTable').appendChild(auxTable );




	//build Modules table	
	modules = xmlhttp.responseXML.documentElement.getElementsByTagName("Module");
	
	//create new table
	newTable = document.createElement("table");
	newTable.className = "data_table";
	newTable.id = "module_table";
	
	caption = newTable.createCaption()
	caption.innerHTML="Modules"
	
	//Created header row
	newTable.createTHead();
	
	headerRow = newTable.tHead.insertRow(-1);
	headerRow .className = "data_table_header";
	
	newCell = headerRow.insertCell(0);
	newCell.innerHTML =  "ID";
	newCell.className = "data_table_header_cell";
			
	newCell = headerRow.insertCell(1);
	newCell.innerHTML =  "Description";
	newCell.className = "data_table_header_cell";

	newCell = headerRow.insertCell(2);
	newCell.innerHTML =  "Volts";
	newCell.className = "data_table_header_cell";	
			 		 		 			
	newCell = headerRow.insertCell(3);
	newCell.innerHTML =  "Amps";
	newCell.className = "data_table_header_cell";	
	
	newCell = headerRow.insertCell(4);
	newCell.innerHTML =  "Power";
	newCell.className = "data_table_header_cell";	
			 		 		 			
	for (i=0; i < modules .length; i++){	
		newRow = newTable.insertRow(-1);
		
		try{	
			modId = modules[i].getAttribute("id");
		}catch(er){
			modId = "unknown";
		}
		newCell = newRow .insertCell(0);
		newCell.innerHTML = modId ;
		newCell.className = "data_table_cell";
	
		
		try{	
			descript = modules[i].getAttribute("description");
		}catch(er){
			descript = "unknown";
		}
		newCell = newRow .insertCell(1);
		newCell.innerHTML = descript ;
		newCell.className = "data_table_cell";
		
		try{	
			value = parseFloat(modules[i].getAttribute("volts")).toFixed(voltsDigits);
		}catch(er){
			value = "unknown";
		}
		newCell = newRow .insertCell(2);
		newCell.innerHTML = value ;
		newCell.className = "data_table_cell";

		try{	
			value = parseFloat(modules[i].getAttribute("amps")).toFixed(ampsDigits);
		}catch(er){
			value = "unknown";
		}
		newCell = newRow .insertCell(3);
		newCell.innerHTML = value ;
		newCell.className = "data_table_cell";
	

		try{	
			value = parseFloat(modules[i].getAttribute("power")).toFixed(powerDigits);
		}catch(er){
			value = "unknown";
		}
		newCell = newRow .insertCell(4);
		newCell.innerHTML = value ;
		newCell.className = "data_table_cell";

	}//end for i = 
	
	try {
		document.getElementById('modTable').removeChild( modTable  );//remove previous table
	}catch(er) {
	}
	modTable  = newTable;
	document.getElementById('modTable').appendChild(modTable  );


	//set it up to automatically request data
	curTime = new Date().getTime();
	setTimeout(getSample, 1000 -(curTime%1000) );
} //onResponse

//////////////////////////////////////////////////////////////////////////////////////////////
function xmlTimeout()
{
	alert("XML Timeout");
}


